	LIST P=12F675, R=DEC
	include P12F675.INC
	LIST

	__CONFIG	_CPD_OFF &  _CP_OFF & _BODEN_ON & _MCLRE_OFF & _PWRTE_ON & _WDT_ON & _INTRC_OSC_NOCLKOUT

;==================================================================
;       1 .   
; 64 uS (15,625 kHz).    7  6  TMR0    .
;           OUT_HIGH  OUT_LOW.
;
;      ,     
;  .         .   
;    OUT_HIGH  OUT_LOW  .
;******************************************************************
; Definitions
;==================================================================
;
; I/O, Interrupt and Option Definitions
;
	constant	C_OPTION_VAL = B'11011000'	
				;   			
				;       INT (   )
				;    TMR0
				; TMR0      (   )
				;   WDT
				;  1/1

	constant	C_INTCONVAL = B'10100000'	; set GIE, T0IE

	constant	C_TRIS_VAL   = B'11011100'	; GP0, GP1, GP5 output
	constant	C_AN_SEL_VAL = B'01100000'	; ADC  1/64 Tosc,   

	constant	C_ADCON0VAL = B'00000000' ;   
;--------------------------------------------------------------------
	constant	C_GLOBAL_GONG_TIME = D'152'   ;      . 10 sec.

	constant	C_TONE_1_MAX_VOLUME = D'20'	;  ()   .
	constant	C_TONE_2_MAX_VOLUME = D'24'
	constant	C_TONE_3_MAX_VOLUME = D'30'

	constant	C_TONE_1_BEGIN_TIME = C_GLOBAL_GONG_TIME - D'01'	;     
	constant	C_TONE_2_BEGIN_TIME = C_GLOBAL_GONG_TIME - D'19'	;  65536  uS.
	constant	C_TONE_3_BEGIN_TIME = C_GLOBAL_GONG_TIME - D'37'

	constant	C_TONE_1_LENGHT = D'67'	; 67 * 65536 uS = 4,4 Sec
	constant	C_TONE_2_LENGHT = D'67'	; 67 * 65536 uS = 4,4 Sec
	constant	C_TONE_3_LENGHT = D'67'	; 67 * 65536 uS = 4,4 Sec

	constant	C_TONE_1_DECREMENT_STEP = C_TONE_1_LENGHT / C_TONE_1_MAX_VOLUME
	constant	C_TONE_2_DECREMENT_STEP = C_TONE_2_LENGHT / C_TONE_2_MAX_VOLUME
	constant	C_TONE_3_DECREMENT_STEP = C_TONE_3_LENGHT / C_TONE_2_MAX_VOLUME

	constant	C_TONE_1_PHASE_START = D'10'	;     .
	constant	C_TONE_2_PHASE_START = D'12'	;   .
	constant	C_TONE_3_PHASE_START = D'15'	;       ???
;---------------
	CONSTANT  C_MIN_PWM_VALUE  = D'50'
	CONSTANT  C_MAX_PWM_VALUE = D'100' + C_MIN_PWM_VALUE
	CONSTANT	 C_PWM_BASE = ( C_MAX_PWM_VALUE - C_MIN_PWM_VALUE ) / 2 + C_MIN_PWM_VALUE	;     
;==================================================================
	#define		DING_DANG_IN		GPIO,4
	#define		DING_DANG_DONG_IN	GPIO,2

	#define		TONE_PIN	GPIO,5	; GPIO,0	GPIO,1
;==================================================================
; Register Definitions

	CBLOCK	H'20'

	W_TEMP		; stack to push/pop the W-register
	STATUS_TEMP

	TONES_PWM	; 

	GLOBAL_GONG_TMR		;      .  65536 uS.

	TONE_1_VOLUME	;    
	TONE_2_VOLUME
	TONE_3_VOLUME

	COUNTER_TONE_1_DOWN		;      
	COUNTER_TONE_2_DOWN		;  
	COUNTER_TONE_3_DOWN

	PHASE_TONE_1_COUNTER		;      .
	PHASE_TONE_2_COUNTER		;  '00'    C_TONE_x_PHASE_START
	PHASE_TONE_3_COUNTER

	COMMON_STATUS		;  


	ENDC
;==================================================================
	#define	SOUND_ON	COMMON_STATUS,0		;   '00'    0
							;    -
	#define	TONE_1_HIGH	COMMON_STATUS,1
	#define	TONE_2_HIGH	COMMON_STATUS,2
	#define	TONE_3_HIGH	COMMON_STATUS,3

;	#define		COMMON_STATUS,4
;	#define		COMMON_STATUS,5
;	#define		COMMON_STATUS,6
;	#define		COMMON_STATUS,7

;******* RESET ****************************************************
	ORG H'00'
	goto START

;*******  ISR  ****************************************************
	ORG H'04'		; timer interrupt

	btfsc	TMR0,0		; compensate comp time of 1/2 cyc
	goto	PwmInt		; instruc when timer int occured
PwmInt
;------------------------------------------------------------------
	bcf	INTCON,T0IF	; Clear TMR0 overflow flag

	movWf	W_TEMP		; Temporarily save W
	swapf	STATUS,W	; copy STATUS register...
	movWf	STATUS_TEMP	; ...to "stack"
;------------------------------------------------------------------
	btfss	SOUND_ON
	goto	PWMLow		;    0,    

	btfsc	TONE_PIN	; Was this a Low cycle ?
	goto	PWMLow		; No ... 
;-------
;PWMHigh
	movFw	TONES_PWM	; Yes... Load high time
	bsf	TONE_PIN
	movWf	TMR0		; Load next edge interupt time

;-------------------------------------------------------------
; 		    
;-------------------------------------------------------------
;DEC_T1
	decfsz	PHASE_TONE_1_COUNTER,F		;  1
	goto	DEC_T2

	movlw	C_TONE_1_PHASE_START
	movwf	PHASE_TONE_1_COUNTER

	movlw	B'00000010'
	xorwf	COMMON_STATUS,F
;-------
DEC_T2
	decfsz	PHASE_TONE_2_COUNTER,F		;  2
	goto	DEC_T3

	movlw	C_TONE_2_PHASE_START
	movwf	PHASE_TONE_2_COUNTER

	movlw	B'00000100'
	xorwf	COMMON_STATUS,F
;-------
DEC_T3
	decfsz	PHASE_TONE_3_COUNTER,F		;  3
	goto	END_Tx_DEC

	movlw	C_TONE_3_PHASE_START
	movwf	PHASE_TONE_3_COUNTER

	movlw	B'00001000'
	xorwf	COMMON_STATUS,F
;-------
END_Tx_DEC
;-------------------------------------------------------------
	goto	ISR_END
;=============================================================
PWMLow	
	movFw	TONES_PWM		; Load low time
	bcf	TONE_PIN
	sublw	C_MAX_PWM_VALUE
	movWf	TMR0		; Load next edge interupt time
;	nop
;-------------------------------------------------------------
	movlw	C_PWM_BASE
	movwf	TONES_PWM

;------    _1   ----------
	movfw	TONE_1_VOLUME

	btfsc	TONE_1_HIGH
	addwf	TONES_PWM,F

	btfss	TONE_1_HIGH
	subwf	TONES_PWM,F

;------    _2   ----------
	movfw	TONE_2_VOLUME

	btfsc	TONE_2_HIGH
	addwf	TONES_PWM,F

	btfss	TONE_2_HIGH
	subwf	TONES_PWM,F

;------    _3   ----------
	movfw	TONE_3_VOLUME

	btfsc	TONE_3_HIGH
	addwf	TONES_PWM,F

	btfss	TONE_3_HIGH
	subwf	TONES_PWM,F

;-------------------------------------------------------------
ISR_END
	bsf	TMR0,7		;     128 uS ! ! !    min 3906.25 Hz. 6 Fmax

	swapf	STATUS_TEMP,W	; restore ...
	movWf	STATUS		; ...STATUS register
	swapf	W_TEMP,F	; restore W register
	swapf	W_TEMP,W

	retfie			; ~ 45 
;******************************************************************
;			ISR   END
;******************************************************************

;--- power on routine ---------------------------------------------
START
				;    
	bsf	STATUS,RP0	; Bank 1
	movlw	H'80'
;	call	H'3FF'		; Get the cal value
	movWf	OSCCAL		; Calibrate
	bcf	STATUS,RP0 	; Bank 0



; configuration of the PWM module
	clrf	TMR0		; reset timer
	bcf	TONE_PIN	; reset PWM-port before GPIO is changed

	movLw	B'00000111'
	movWf	CMCON		;  

				; configuration of the Pic
	bsf	STATUS,RP0	; register page 1
	movLw	C_TRIS_VAL	; configurate ...
	movWf	TRISIO		; ...GP port
	movLw	C_AN_SEL_VAL	;   / 
	movWf	ANSEL
	movLw	C_OPTION_VAL	; configurate ...
	movWf	OPTION_REG	; ...Pic
	bcf	STATUS,RP0	; register page 0

	movLw	C_ADCON0VAL	;  
	movWf	ADCON0

	movLw	B'00000001'	;  T1G
	movWf	T1CON		;  1:1
				;     OSC1
				;       
				;  
				;   TMR1

	clrf	TMR1L
	clrf	TMR1H
	clrf	GLOBAL_GONG_TMR

;-----------------------------------------------------------------------
	movLw	C_TONE_1_DECREMENT_STEP	;        
	movWf	COUNTER_TONE_1_DOWN

	movLw	C_TONE_2_DECREMENT_STEP
	movWf	COUNTER_TONE_2_DOWN

	movLw	C_TONE_3_DECREMENT_STEP
	movWf	COUNTER_TONE_3_DOWN

;-----------------------------------------------------------------------
	clrf	TONE_1_VOLUME		;       
	clrf	TONE_2_VOLUME
	clrf	TONE_3_VOLUME
	clrf	COMMON_STATUS

	movlw	D'1'				;    
	movwf	PHASE_TONE_1_COUNTER		;  1
	movwf	PHASE_TONE_2_COUNTER		;  2
	movwf	PHASE_TONE_3_COUNTER		;  3

;    ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !
	movlw	C_PWM_BASE
	movWf	TONES_PWM

;***********************************************************************
	movLw	C_INTCONVAL		; configure interrupts and ...
	movWf	INTCON			; ...enable interrupts
;==== main idle =============================
MAIN
	clrwdt	; toggle watchdog

	tstf	GLOBAL_GONG_TMR
	skpnz
	goto	EMPTY_GLOBAL_GONG_TMR
;-------------------------------------------------------------------------
	btfss	PIR1,T1IF		;         TMR1
	goto	MAIN			; -> -> -> -> -> -> -> ->
;---------------------------------------
	bcf	PIR1,T1IF		;  
	decf	GLOBAL_GONG_TMR,F	;   .

;    ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !
	incf	TONES_PWM,F
	goto	MAIN
;    ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !


;-------
;CHCK_TONE_1_START
	movFw	GLOBAL_GONG_TMR		;       
	xorLw	C_TONE_1_BEGIN_TIME
	skpz
	goto	CHCK_TONE_2_START

	movlw	C_TONE_1_MAX_VOLUME
	movwf	TONE_1_VOLUME
;----------------
CHCK_TONE_2_START
	movFw	GLOBAL_GONG_TMR		;       
	xorLw	C_TONE_2_BEGIN_TIME
	skpz
	goto	CHCK_TONE_3_START

	movlw	C_TONE_2_MAX_VOLUME
	movwf	TONE_2_VOLUME
;----------------
CHCK_TONE_3_START
	movFw	GLOBAL_GONG_TMR		;       
	xorLw	C_TONE_3_BEGIN_TIME
	skpz
	goto	END_WAIT_TONES_START

	movlw	C_TONE_3_MAX_VOLUME
	movwf	TONE_3_VOLUME

END_WAIT_TONES_START
;-----------------------------------------------------------------------
; DEC_VOLUME_1			;      (   '00')

	tstf	TONE_1_VOLUME
	skpnz
	goto	END_DEC_TONE_1

	decfsz	COUNTER_TONE_1_DOWN,F
	goto	END_DEC_TONE_1

	movLw	C_TONE_1_DECREMENT_STEP
	movWf	COUNTER_TONE_1_DOWN

	decf	TONE_1_VOLUME,F

END_DEC_TONE_1
;-----
;DEC_VOLUME_2			;      (   '00')

	tstf	TONE_2_VOLUME
	skpnz
	goto	END_DEC_TONE_2

	decfsz	COUNTER_TONE_2_DOWN,F
	goto	END_DEC_TONE_2

	movLw	C_TONE_2_DECREMENT_STEP
	movWf	COUNTER_TONE_2_DOWN

	decf	TONE_2_VOLUME,F

END_DEC_TONE_2
;-----
;DEC_VOLUME_3			;      (   '00')

	tstf	TONE_3_VOLUME
	skpnz
	goto	END_DEC_TONE_3

	decfsz	COUNTER_TONE_3_DOWN,F
	goto	END_DEC_TONE_3

	movLw	C_TONE_3_DECREMENT_STEP
	movWf	COUNTER_TONE_3_DOWN

	decf	TONE_3_VOLUME,F

END_DEC_TONE_3
;-----
;END_VOLUME_DECREMENT


	goto	MAIN
;------------------------------------------------------------------------
EMPTY_GLOBAL_GONG_TMR

	movLw	C_TONE_1_DECREMENT_STEP
	movWf	COUNTER_TONE_1_DOWN

	movLw	C_TONE_2_DECREMENT_STEP
	movWf	COUNTER_TONE_2_DOWN

	movLw	C_TONE_3_DECREMENT_STEP
	movWf	COUNTER_TONE_3_DOWN
;-------
	btfss	DING_DANG_DONG_IN
	goto	MAIN

	movLw	C_GLOBAL_GONG_TIME
	movWf	GLOBAL_GONG_TMR

	bsf	SOUND_ON

	goto	MAIN		; ...then waiting

;------------------------------------------------------------------

	ORG H'3FF'

	retlw	H'80'		;   


	END
