	LIST P=12F675, R=DEC
	include P12F675.INC
	LIST

	__CONFIG	_CPD_OFF &  _CP_OFF & _BODEN_ON & _MCLRE_OFF & _PWRTE_ON & _WDT_ON & _INTRC_OSC_NOCLKOUT

;******************************************************************
; Definitions
;******************************************************************
;
; I/O, Interrupt and Option Definitions
;
	constant	OPTION_VAL = B'11011000'	
				;   			
				;       INT (   )
				;    TMR0
				; TMR0      (   )
				;   WDT
				;  1/1

	constant	INTCONVAL = B'10100000'	; set GIE, T0IE
						; GPIO

	constant	UINPBIT   = H'00'	; analog input for desired PWM

	constant	TRIS_VAL   = B'11011100'	; GP0, GP1, GP5 output
	constant	AN_SEL_VAL = B'01100000'	; ADC  1/64 Tosc,   

	constant	ADCON0VAL = B'00000000' ;   


	#define		TONE_1_OUT_PIN	GPIO,5
	#define		TONE_2_OUT_PIN	GPIO,0
	#define		TONE_3_OUT_PIN	GPIO,1

	#define		DING_DANG_IN		GPIO,4
	#define		DING_DANG_DONG_IN	GPIO,2

;------------------------------------------------------------------
; Register Definitions

	CBLOCK	H'20'

	W_TEMP		; stack to push/pop the W-register
	STATUS_TEMP	; stack to push/pop the STATUS-reg

	PWM_TONE_1	;   1
	PWM_TONE_2	;   2
	PWM_TONE_3	;   3

	PWM_TONE_1_COUNTER	;      1
	PWM_TONE_2_COUNTER	;      2
	PWM_TONE_3_COUNTER	;      3

	GLOBAL_GONG_TMR		;      .  65536 uS.

	COUNTER_PWM_1_DECREASE		;      
	COUNTER_PWM_2_DECREASE		;  
	COUNTER_PWM_3_DECREASE


	ENDC
;------------------------------------------------------------------
; PWM-module-constant

	constant	BASE_FREQ_CONST = D'76'	; 13158 Hz
;---------------
	constant	TONE_1_MAX_PWM_CONS = D'20'	;  .  1.
	constant	TONE_2_MAX_PWM_CONS = D'24'
	constant	TONE_3_MAX_PWM_CONS = D'30'

	constant	TONE_1_PWM_START_CONST = D'10'	;     .
	constant	TONE_2_PWM_START_CONST = D'12'
	constant	TONE_3_PWM_START_CONST = D'15'
;---------------
	constant	GLOBAL_GONG_TIME_CONST  = D'152'   ;      . 10 sec.

	constant	TONE_1_BEGIN_TIME_CONST = GLOBAL_GONG_TIME_CONST - D'00'	;     
	constant	TONE_2_BEGIN_TIME_CONST = GLOBAL_GONG_TIME_CONST - D'18'	;  65536  uS.
	constant	TONE_3_BEGIN_TIME_CONST = GLOBAL_GONG_TIME_CONST - D'36'


	constant	TONE_1_LENGHT = D'67'	; 67 * 65536 uS = 4,4 Sec
	constant	TONE_2_LENGHT = D'67'	; 67 * 65536 uS = 4,4 Sec
	constant	TONE_3_LENGHT = D'67'	; 67 * 65536 uS = 4,4 Sec

	constant	TONE_1_PWM_DECREMENT_STEP = TONE_1_LENGHT / TONE_1_PWM_START_CONST
	constant	TONE_2_PWM_DECREMENT_STEP = TONE_2_LENGHT / TONE_2_PWM_START_CONST
	constant	TONE_3_PWM_DECREMENT_STEP = TONE_3_LENGHT / TONE_3_PWM_START_CONST


;==================================================================
	ORG 0
	goto PowerOn
;--- PWM-Generator ------------------------------------------------
	ORG 04h ; timer interrupt

	btfsc	TMR0,0		; compensate comp time of 1/2 cyc
	goto	PwmInt		; instruc when timer int occured
PwmInt

	movWf	W_TEMP		; copy W register... to "stack"
	swapf	W_TEMP,F	; ...to "stack"
	swapf	STATUS,W	; copy STATUS register...
	movWf	STATUS_TEMP	; ...to "stack"
	bcf	INTCON,T0IF	; clear interrupt flag
				;   9 ?  + 2  

	movLw	H'100' - BASE_FREQ_CONST + D'13'	; 12- 
	movwf	TMR0					; 13- 

;------------------------------------------------------------------------------
	decf	PWM_TONE_1_COUNTER,F	;    
	movLw	TONE_1_MAX_PWM_CONS	;  TONE_x_MAX_PWM_CONS  1.
	tstf	PWM_TONE_1_COUNTER	;  .
	skpnz
	movwf	PWM_TONE_1_COUNTER
;-----
	decf	PWM_TONE_2_COUNTER,F
	movLw	TONE_2_MAX_PWM_CONS
	tstf	PWM_TONE_2_COUNTER
	skpnz
	movwf	PWM_TONE_2_COUNTER
;-----
	decf	PWM_TONE_3_COUNTER,F
	movLw	TONE_3_MAX_PWM_CONS
	tstf	PWM_TONE_3_COUNTER
	skpnz
	movwf	PWM_TONE_3_COUNTER
;--------------------------------------------------------------------------------
	movfw	PWM_TONE_1_COUNTER	;     .
	subwf	PWM_TONE_1,W
	skpnc
	bsf	TONE_1_OUT_PIN	; C=1.   . PWM_TONE_1 => PWM_TONE_1_COUNTER
	skpc
	bcf	TONE_1_OUT_PIN	; C=0.   .  PWM_TONE_1 <  PWM_TONE_1_COUNTER
;-----
	movfw	PWM_TONE_2_COUNTER
	subwf	PWM_TONE_2,W
	skpnc
	bsf	TONE_2_OUT_PIN	; C=1.   . PWM_TONE_2 => PWM_TONE_2_COUNTER
	skpc
	bcf	TONE_2_OUT_PIN	; C=0.   .  PWM_TONE_2 <  PWM_TONE_2_COUNTER
;-----
	movfw	PWM_TONE_3_COUNTER
	subwf	PWM_TONE_3,W
	skpnc
	bsf	TONE_3_OUT_PIN	; C=1.   . PWM_TONE_3 => PWM_TONE_3_COUNTER
	skpc
	bcf	TONE_3_OUT_PIN	; C=0.   .  PWM_TONE_3 <  PWM_TONE_3_COUNTER
;--------------------------------------------------------------------------------
	swapf	STATUS_TEMP,W	; restore ...
	movWf	STATUS		; ...STATUS register
	swapf	W_TEMP,W	; restore W register
	retfie			; return to main program
;******************************************************************
;			ISR   END
;******************************************************************

;--- power on routine ---------------------------------------------
PowerOn
				;    
	bsf	STATUS,RP0	; Bank 1
	call	H'3FF'		; Get the cal value
	movwf	OSCCAL		; Calibrate
	bcf	STATUS,RP0 	; Bank 0



; configuration of the PWM module
	clrf	TMR0		; reset timer

	bcf	TONE_1_OUT_PIN	; reset PWM-port before port A is
	bcf	TONE_2_OUT_PIN	; changed from input to output to
	bcf	TONE_3_OUT_PIN	; suppress an uncontrolled spike

	movLw	B'00000111'
	movwf	CMCON		;  

				; configuration of the Pic
	bsf	STATUS,RP0	; register page 1
	movLw	TRIS_VAL	; configurate ...
	movWf	TRISIO		; ...GP port
	movLw	AN_SEL_VAL	;   / 
	movWf	ANSEL
	movLw	OPTION_VAL	; configurate ...
	movWf	OPTION_REG	; ...Pic
	bcf	STATUS,RP0	; register page 0

	movLw	ADCON0VAL	;  
	movWf	ADCON0

	movLw	B'00000001'	;  T1G
	movwf	T1CON		;  1:1
				;     OSC1
				;       
				;  
				;   TMR1

	clrf	TMR1L
	clrf	TMR1H
	clrf	GLOBAL_GONG_TMR

;-----------------------------------------------------------------------
	movLw	TONE_1_MAX_PWM_CONS	;     
	movwf	PWM_TONE_1_COUNTER
	clrf	PWM_TONE_1		;   
	movLw	TONE_1_PWM_DECREMENT_STEP
	movwf	COUNTER_PWM_1_DECREASE

	movLw	TONE_2_MAX_PWM_CONS
	movwf	PWM_TONE_2_COUNTER
	clrf	PWM_TONE_2
	movLw	TONE_2_PWM_DECREMENT_STEP
	movwf	COUNTER_PWM_2_DECREASE

	movLw	TONE_3_MAX_PWM_CONS
	movwf	PWM_TONE_3_COUNTER
	clrf	PWM_TONE_3
	movLw	TONE_3_PWM_DECREMENT_STEP
	movwf	COUNTER_PWM_3_DECREASE

;-----------------------------------------------------------------------
	movLw	INTCONVAL		; configure interrupts and ...
	movWf	INTCON			; ...enable interrupts
;==== main idle =============================
MAIN
	clrwdt	; toggle watchdog

	tstf	GLOBAL_GONG_TMR
	skpnz
	goto	EMPTY_GLOBAL_GONG_TMR
;-------------------------------------------------------------------------
	btfss	PIR1,T1IF		;         TMR1
	goto	MAIN

	bcf	PIR1,T1IF		;  

	movfw	GLOBAL_GONG_TMR
	xorLw	TONE_1_BEGIN_TIME_CONST
	movLw	TONE_1_PWM_START_CONST
	skpnz				;       
	movwf	PWM_TONE_1		;     1

	movfw	GLOBAL_GONG_TMR
	xorLw	TONE_2_BEGIN_TIME_CONST
	movLw	TONE_2_PWM_START_CONST
	skpnz				;       
	movwf	PWM_TONE_2		;     2

	movfw	GLOBAL_GONG_TMR
	xorLw	TONE_3_BEGIN_TIME_CONST
	movLw	TONE_3_PWM_START_CONST
	skpnz				;       
	movwf	PWM_TONE_3		;     3
;-----------------------------------------------------------------------





; DEC_PWM_1

	tstf	PWM_TONE_1
	skpnz
	goto	DEC_PWM_2

	decfsz	COUNTER_PWM_1_DECREASE,F
	goto	DEC_PWM_2

	movLw	TONE_1_PWM_DECREMENT_STEP
	movwf	COUNTER_PWM_1_DECREASE

	tstf	PWM_TONE_1
	skpz
	decf	PWM_TONE_1,F		;     

;-----
DEC_PWM_2
	tstf	PWM_TONE_2
	skpnz
	goto	DEC_PWM_3

	decfsz	COUNTER_PWM_2_DECREASE,F
	goto	DEC_PWM_3

	movLw	TONE_2_PWM_DECREMENT_STEP
	movwf	COUNTER_PWM_2_DECREASE

	tstf	PWM_TONE_2
	skpz
	decf	PWM_TONE_2,F

;-----
DEC_PWM_3
	tstf	PWM_TONE_3
	skpnz
	goto	END_PWM_DECREMENT

	decfsz	COUNTER_PWM_3_DECREASE,F
	goto	END_PWM_DECREMENT

	movLw	TONE_3_PWM_DECREMENT_STEP
	movwf	COUNTER_PWM_3_DECREASE

	tstf	PWM_TONE_3
	skpz
	decf	PWM_TONE_3,F

;-----
END_PWM_DECREMENT





















	decf	GLOBAL_GONG_TMR,F

	goto	MAIN
;------------------------------------------------------------------------
EMPTY_GLOBAL_GONG_TMR

	movLw	TONE_1_PWM_DECREMENT_STEP
	movwf	COUNTER_PWM_1_DECREASE

	movLw	TONE_2_PWM_DECREMENT_STEP
	movwf	COUNTER_PWM_2_DECREASE

	movLw	TONE_3_PWM_DECREMENT_STEP
	movwf	COUNTER_PWM_3_DECREASE
;-------
	btfss	DING_DANG_DONG_IN
	goto	MAIN

	movLw	GLOBAL_GONG_TIME_CONST
	movwf	GLOBAL_GONG_TMR



	nop
	nop


	goto	MAIN		; ...then waiting

;------------------------------------------------------------------

	ORG H'3FF'

	retlw	H'64'		;   


	END
