;==========================================================================
;      .
;==========================================================================
IRQ_OFF	MACRO
        bcf 	INTCON, GIE
	nop
	btfsc	INTCON, GIE
        goto    $-D'3'

	ENDM
;==========================================================================
IRQ_ON	MACRO
	bsf	INTCON,GIE
	ENDM
;==========================================================================
;         .
;==========================================================================
LLCALL	MACRO	ADDRESS
	lcall	ADDRESS
	PAGESEL	$
	ENDM
;==========================================================================
;      K -  W ().
;==========================================================================
BGT	MACRO	ADDRESS
	btfsc	STATUS,Z
	goto	$+3
	btfsc	STATUS,C
	goto	ADDRESS
	ENDM
;==========================================================================
;      K -    W ().
;==========================================================================
BGE	MACRO	ADDRESS
	btfsc	STATUS,C
	goto	ADDRESS
	ENDM
;==========================================================================
;      K -  W ().
;==========================================================================
BLT	MACRO	ADDRESS
	btfss	STATUS,C
	goto	ADDRESS
	ENDM
;==========================================================================
;      K -    W ().
;==========================================================================
BLE	MACRO	ADDRESS
	btfsc	STATUS,Z
	goto	ADDRESS
	btfss	STATUS,C
	goto	ADDRESS
	ENDM
;==========================================================================
;      K -    W ().
;==========================================================================
SKPGE	MACRO
	btfss	STATUS,C
	ENDM
;==========================================================================
;      K -  W ().
;==========================================================================
SKPLT	MACRO
	btfsc	STATUS,C
	ENDM
;==========================================================================
;        10-   8  .
;   Z, DC.
;==========================================================================
AD_ROUND MACRO
	bsf	STATUS,RP0	; BANK 1
	clrdc
	btfsc	ADRESL,7
	setdc
	bcf	STATUS,RP0	; BANK 0
	skpdc
	goto	$+5

	incf	ADRESH,F
	tstf	ADRESH
	skpnz
	decf	ADRESH,F
	ENDM
;==========================================================================
;    16   . ,  .  C.
;==========================================================================
RRF_16	MACRO	ADDRESS_HI, ADDRESS_LO
	clrc
	rrf	ADDRESS_HI,F
	rrf	ADDRESS_LO,F
	ENDM
;==========================================================================

